/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/impl/AlreadyInitialisedException.java,v 1.5 2005/06/07 20:25:33 gnt Exp $
 * $Revision: 1.5 $
 * $Date: 2005/06/07 20:25:33 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.impl;

import org.mule.config.i18n.Message;
import org.mule.config.i18n.Messages;
import org.mule.umo.lifecycle.InitialisationException;

/**
 * <code>AlreadyInitialisedException</code> is thrown when a component or
 * connector has already been initialised.
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.5 $
 */

public class AlreadyInitialisedException extends InitialisationException
{
    /**
     * @param object the object that has been initialised and cannot be
     *            initialised again
     */
    public AlreadyInitialisedException(String name, Object object)
    {
        super(new Message(Messages.OBJECT_X_ALREADY_INITIALISED, name), object);
    }
}
