/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/management/mbeans/ModelServiceMBean.java,v 1.3 2005/06/03 01:17:25 gnt Exp $
 * $Revision: 1.3 $
 * $Date: 2005/06/03 01:17:25 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.management.mbeans;

import org.mule.umo.UMODescriptor;
import org.mule.umo.UMOException;

/**
 * <code>ModelServiceMBean</code> JMX Service interface for the UMOModel
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.3 $
 */
public interface ModelServiceMBean
{

    void start() throws UMOException;

    void stop() throws UMOException;

    boolean isComponentRegistered(String name);

    UMODescriptor getComponentDescriptor(String name);

    void startComponent(String name) throws UMOException;

    void stopComponent(String name) throws UMOException;

    void pauseComponent(String name) throws UMOException;

    void resumeComponent(String name) throws UMOException;

    void unregisterComponent(String name) throws UMOException;

    String getName();
}
