/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/model/TooManySatisfiableMethodsException.java,v 1.4 2005/06/03 01:17:25 gnt Exp $
 * $Revision: 1.4 $
 * $Date: 2005/06/03 01:17:25 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */

package org.mule.model;

import org.mule.config.i18n.Message;
import org.mule.config.i18n.Messages;
import org.mule.umo.model.ModelException;
import org.mule.util.StringMessageHelper;

/**
 * <code>TooManySatisfiableMethodsException</code> is thrown by
 * EntryPointResolvers when the component passed has more than one methods that
 * meet the criteria of the configured EntryPointResolver.
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.4 $
 * @see org.mule.umo.model.UMOEntryPointResolver
 */
public class TooManySatisfiableMethodsException extends ModelException
{
    /**
     * @param component
     */
    public TooManySatisfiableMethodsException(Object component)
    {
        super(new Message(Messages.TOO_MANY_ENTRY_POINTS_ON_X, StringMessageHelper.getObjectValue(component)));
    }

    public TooManySatisfiableMethodsException(Object component, Exception cause)
    {
        super(new Message(Messages.TOO_MANY_ENTRY_POINTS_ON_X, StringMessageHelper.getObjectValue(component)), cause);
    }
}
