/* 
* $Header: /home/projects/mule/scm/mule/providers/jbi/src/java/org/mule/providers/jbi/JbiUtils.java,v 1.3 2005/09/06 16:11:29 rossmason Exp $
* $Revision: 1.3 $
* $Date: 2005/09/06 16:11:29 $
* ------------------------------------------------------------------------------------------------------
* 
* Copyright (c) SymphonySoft Limited. All rights reserved.
* http://www.symphonysoft.com
* 
* The software in this package is published under the terms of the BSD
* style license a copy of which has been included with this distribution in
* the LICENSE.txt file. 
*
*/
package org.mule.providers.jbi;

import org.mule.config.MuleProperties;
import org.mule.impl.MuleMessage;
import org.mule.umo.UMOMessage;

import javax.jbi.messaging.MessagingException;
import javax.jbi.messaging.NormalizedMessage;
import javax.xml.transform.Source;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 * Useful for converting message types
 *
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.3 $
 */
public class JbiUtils {

    public static UMOMessage createMessage(NormalizedMessage message) throws MessagingException {

        Map properties = new HashMap();
        for (Iterator iterator = message.getPropertyNames().iterator(); iterator.hasNext();) {
            String s = (String) iterator.next();
            properties.put(s, message.getProperty(s));
        }
        if (message.getSecuritySubject() != null) {
            properties.put(MuleProperties.MULE_USER_PROPERTY, message.getSecuritySubject());
        }
        try {
            //todo source transformer
            Source source = message.getContent();
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            StreamResult result = new StreamResult(baos);
            TransformerFactory.newInstance().newTransformer().transform(source, result);
            UMOMessage msg = new MuleMessage(baos.toByteArray(), properties);
            baos.close();
            return msg;
        } catch (Exception e) {
            throw new MessagingException(e.getMessage(), e);
        }
    }

    public static void populateNormalizedMessage(UMOMessage muleMessage, NormalizedMessage message) throws MessagingException {
        try {
            message.setContent(new StreamSource(new ByteArrayInputStream(muleMessage.getPayloadAsBytes())));
        } catch (Exception e) {
            throw new MessagingException(e.getMessage(), e);
        }

        for (Iterator iterator = muleMessage.getPropertyNames(); iterator.hasNext();) {
            String s = (String)iterator.next();
            message.setProperty(s, muleMessage.getProperty(s));
        }
        for (Iterator iterator = muleMessage.getAttachmentNames().iterator(); iterator.hasNext();) {
            String s = (String) iterator.next();
            message.addAttachment(s, muleMessage.getAttachment(s));
        }
    }
}
