/* 
* $Header: /home/projects/mule/scm/mule/providers/xmpp/src/java/org/mule/providers/xmpp/XmppEndpointBuilder.java,v 1.1 2005/08/28 11:01:02 rossmason Exp $
* $Revision: 1.1 $
* $Date: 2005/08/28 11:01:02 $
* ------------------------------------------------------------------------------------------------------
* 
* Copyright (c) SymphonySoft Limited. All rights reserved.
* http://www.symphonysoft.com
* 
* The software in this package is published under the terms of the BSD
* style license a copy of which has been included with this distribution in
* the LICENSE.txt file. 
*
*/
package org.mule.providers.xmpp;

import org.mule.config.i18n.Message;
import org.mule.impl.endpoint.UserInfoEndpointBuilder;
import org.mule.umo.endpoint.MalformedEndpointException;

import java.net.URI;
import java.util.Properties;

/**
 * Does the same as the UserINfoEndpointBuilder but also ensures that a path is
 * set on the uri.  The path is used as either the groupChat name or the recipient name
 * of a one on one chat.
 *
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.1 $
 */
public class XmppEndpointBuilder extends UserInfoEndpointBuilder
{
    protected void setEndpoint(URI uri, Properties props) throws MalformedEndpointException
    {
        if(uri.getPath().length()==0) {
            throw new MalformedEndpointException(new Message("xmpp", 1), uri.toString());
        }
        if(props.getProperty(XmppConnector.XMPP_GROUP_CHAT, "false").equalsIgnoreCase("true")) {
            if(props.getProperty(XmppConnector.XMPP_NICKNAME, null)==null) {
                throw new MalformedEndpointException(new Message("xmpp", 2), uri.toString());
            }
        }
        super.setEndpoint(uri, props);
    }
}
