/* 
* $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/routing/filters/ExceptionTypeFilter.java,v 1.1 2005/08/23 09:12:08 rossmason Exp $
* $Revision: 1.1 $
* $Date: 2005/08/23 09:12:08 $
* ------------------------------------------------------------------------------------------------------
* 
* Copyright (c) SymphonySoft Limited. All rights reserved.
* http://www.symphonysoft.com
* 
* The software in this package is published under the terms of the BSD
* style license a copy of which has been included with this distribution in
* the LICENSE.txt file. 
*
*/
package org.mule.routing.filters;

import org.mule.umo.UMOMessage;

/**
 * tA fitler that accepts messages that have an exception payload. An Exception
 * type can also be set on this filter to allow it to accept Exception messages
 * of a particular Exception class only.
 *
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.1 $
 */
public class ExceptionTypeFilter extends PayloadTypeFilter
{
    public ExceptionTypeFilter() {
    }

    public ExceptionTypeFilter(Class expectedType) {
        super(expectedType);
    }

    /**
     * Check a given message against this filter.
     *
     * @param message a non null message to filter.
     * @return <code>true</code> if the message matches the filter
     */
    public boolean accept(UMOMessage message) {
        if(getExpectedType()==null)
        {
            return message.getExceptionPayload()!=null;
        } else if (message.getExceptionPayload()!=null){
            return getExpectedType().isAssignableFrom(message.getExceptionPayload().getException().getClass());
        } else {
            return false;
        }
    }
}
