/* 
* $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/transformers/codec/SgmlEntityDecoder.java,v 1.1 2005/07/31 18:56:57 rossmason Exp $
* $Revision: 1.1 $
* $Date: 2005/07/31 18:56:57 $
* ------------------------------------------------------------------------------------------------------
* 
* Copyright (c) SymphonySoft Limited. All rights reserved.
* http://www.symphonysoft.com
* 
* The software in this package is published under the terms of the BSD
* style license a copy of which has been included with this distribution in
* the LICENSE.txt file. 
*
*/
package org.mule.transformers.codec;

import org.mule.transformers.AbstractTransformer;
import org.mule.umo.transformer.TransformerException;
import org.mule.util.SgmlCodec;

/**
 * Decodes a string containing SGML entities
 *
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.1 $
 */
public class SgmlEntityDecoder extends AbstractTransformer
{
    public SgmlEntityDecoder()
    {
        registerSourceType(String.class);
        registerSourceType(byte[].class);
        setReturnClass(String.class);
    }

    public Object doTransform(Object src) throws TransformerException
    {
        if(src instanceof byte[]) {
            return SgmlCodec.decodeString(new String((byte[])src));
        } else {
            return SgmlCodec.decodeString(src.toString());
        }
    }
}