/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/umo/provider/UMOConnectable.java,v 1.1 2005/07/11 14:54:53 gnt Exp $
 * $Revision: 1.1 $
 * $Date: 2005/07/11 14:54:53 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 *
 */
package org.mule.umo.provider;

/**
 * Interface for objects that should connect to a resource.
 *
 * @author <a href="mailto:gnt@codehaus.org">Guillaume Nodet</a>
 * @version $Revision: 1.1 $
 */
public interface UMOConnectable {

    /**
     * Make the connection to the underlying transport. 
     * The fact that this object is connected or not should
     * have no influence on the lifecycle, especially
     * the start / stop state if applicable.
     * 
     * @throws Exception
     */
    void connect() throws Exception;

    /**
     * Disconnect the from the underlying transport
     * 
     * @throws Exception
     */
    void disconnect() throws Exception;

    /**
     * Determines if this object is connected or not
     * 
     * @return
     */
    boolean isConnected();
    
    /**
     * Returns a string identifying the underlying resource
     * @return
     */
    String getConnectionDescription();
}
