/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/umo/provider/UMOMessageDispatcher.java,v 1.4 2005/09/03 10:23:28 rossmason Exp $
 * $Revision: 1.4 $
 * $Date: 2005/09/03 10:23:28 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.umo.provider;

import org.mule.umo.UMOEvent;
import org.mule.umo.UMOException;
import org.mule.umo.UMOMessage;
import org.mule.umo.endpoint.UMOEndpointURI;
import org.mule.umo.lifecycle.Disposable;

/**
 * @author Ross Mason <p/> //TODO document
 */
public interface UMOMessageDispatcher extends Disposable
{
    long RECEIVE_WAIT_INDEFINITELY = 0;
    long RECEIVE_NO_WAIT = -1;

    /**
     * Dispatches an event from the endpoint to the external system
     * 
     * @param event The event to dispatch
     * @throws DispatchException if the event fails to be dispatched
     */
    void dispatch(UMOEvent event) throws DispatchException;

    /**
     * Sends an event from the endpoint to the external system
     * 
     * @param event The event to send
     * @return event the response form the external system wrapped in a UMOEvent
     * @throws DispatchException if the event fails to be dispatched
     */
    UMOMessage send(UMOEvent event) throws DispatchException;

    UMOMessage receive(UMOEndpointURI endpointUri, long timeout) throws Exception;

    Object getDelegateSession() throws UMOException;

    UMOConnector getConnector();

    boolean isDisposed();
}
