/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/umo/security/UMOEndpointSecurityFilter.java,v 1.6 2005/07/21 01:02:43 rossmason Exp $
 * $Revision: 1.6 $
 * $Date: 2005/07/21 01:02:43 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.umo.security;

import org.mule.umo.UMOEvent;
import org.mule.umo.endpoint.UMOImmutableEndpoint;
import org.mule.umo.lifecycle.Initialisable;

/**
 * <code>UMOEndpointSecurityFilter</code> is a base filter for secure
 * filtering of inbound and outbout event flow
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.6 $
 */
public interface UMOEndpointSecurityFilter extends Initialisable
{
    /**
     * 
     * @param manager
     */
    void setSecurityManager(UMOSecurityManager manager);

    UMOSecurityManager getSecurityManager();

    String getSecurityProviders();

    void setSecurityProviders(String providers);

    void setEndpoint(UMOImmutableEndpoint endpoint);

    UMOImmutableEndpoint getEndpoint();

    void setCredentialsAccessor(UMOCredentialsAccessor accessor);

    UMOCredentialsAccessor getCredentialsAccessor();

    void authenticate(UMOEvent event) throws SecurityException, UnknownAuthenticationTypeException,
            CryptoFailureException, SecurityProviderNotFoundException, EncryptionStrategyNotFoundException;
}
