/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/umo/security/UMOSecurityProvider.java,v 1.5 2005/06/03 01:20:29 gnt Exp $
 * $Revision: 1.5 $
 * $Date: 2005/06/03 01:20:29 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.umo.security;

import org.mule.umo.lifecycle.Initialisable;

/**
 * <code>UMOSecurityProvider</code> is a target security provider thsat
 * actually does the work of authenticating credentials and populating the
 * UMOAuthentication object.
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.5 $
 */

public interface UMOSecurityProvider extends Initialisable
{
    void setName(String name);

    String getName();

    UMOAuthentication authenticate(UMOAuthentication authentication) throws SecurityException;

    boolean supports(Class aClass);

    UMOSecurityContext createSecurityContext(UMOAuthentication auth) throws UnknownAuthenticationTypeException;
}
