/*
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/umo/security/UnknownAuthenticationTypeException.java,v 1.4 2005/06/03 01:20:29 gnt Exp $
 * $Revision: 1.4 $
 * $Date: 2005/06/03 01:20:29 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.umo.security;

import org.mule.config.i18n.Message;
import org.mule.config.i18n.Messages;
import org.mule.umo.UMOException;

/**
 * <code>UnknownAuthenticationTypeException</code> is thrown if a security
 * context request is make with an unrecognised UMOAuthentication type.
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.4 $
 */

public class UnknownAuthenticationTypeException extends UMOException
{
    public UnknownAuthenticationTypeException(UMOAuthentication authentication)
    {
        super(new Message(Messages.AUTH_TYPE_NOT_RECOGNISED, (authentication == null ? "null"
                : authentication.getClass().getName())));
    }
}
