/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/util/ObjectPool.java,v 1.4 2005/06/03 01:20:29 gnt Exp $
 * $Revision: 1.4 $
 * $Date: 2005/06/03 01:20:29 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.util;

/**
 * <code>ObjectPool</code> is a simple pooling interface for objects
 * 
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.4 $
 */
public interface ObjectPool
{
    /**
     * Constants used to determine the exhaused action of the pool
     */
    int WHEN_EXHAUSTED_FAIL = 0;
    int WHEN_EXHAUSTED_BLOCK = 1;
    int WHEN_EXHAUSTED_GROW = 2;

    int DEFAULT_MAX_SIZE = 5;
    int DEFAULT_MAX_WAIT = 4000;
    int DEFAULT_EXHAUSTED_ACTION = WHEN_EXHAUSTED_BLOCK;

    Object borrowObject() throws Exception;

    void returnObject(Object object) throws Exception;

    int getSize();

    int getMaxSize();

    void setFactory(ObjectFactory factory);

    void clearPool();

    void start() throws Exception;

    void stop() throws Exception;

    void onAdd(Object obj);

    void onRemove(Object obj);
}
