/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/util/counters/impl/InstantRate.java,v 1.2 2005/06/03 01:20:30 gnt Exp $
 * $Revision: 1.2 $
 * $Date: 2005/06/03 01:20:30 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.util.counters.impl;

import org.mule.util.counters.CounterFactory.Type;

/**
 * @author <a href="mailto:gnt@codehaus.org">Guillaume Nodet</a>
 * @version $Revision: 1.2 $
 */
public class InstantRate extends AggregateCounter
{

    private double firstTime;
    private double lastTime;
    private double value;

    public InstantRate(String name, AbstractCounter base)
    {
        super(name, Type.INSTANT_RATE, base);
    }

    public double nextValue()
    {
        if (firstTime == 0 || firstTime == lastTime) {
            return Double.NaN;
        } else {
            return value / (lastTime - firstTime) * 1000.0;
        }
    }

    public void doCompute()
    {
        firstTime = lastTime;
        lastTime = System.currentTimeMillis();
        value = getBase().nextValue();
    }

}
