/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/util/counters/impl/Number.java,v 1.3 2005/06/23 08:01:27 gnt Exp $
 * $Revision: 1.3 $
 * $Date: 2005/06/23 08:01:27 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.util.counters.impl;

import org.mule.util.counters.CounterFactory.Type;

/**
 * @author <a href="mailto:gnt@codehaus.org">Guillaume Nodet</a>
 * @version $Revision: 1.3 $
 */
public class Number extends AbstractCounter
{

    private double value = 0.0;

    public Number(String name)
    {
        super(name, Type.NUMBER);
    }

    public synchronized double increment()
    {
        this.value++;
        propagate();
        return this.value;
    }

    public synchronized double incrementBy(double value)
    {
        this.value += value;
        propagate();
        return this.value;
    }

    public synchronized double decrement()
    {
        this.value--;
        propagate();
        return this.value;
    }

    public synchronized void setRawValue(double value)
    {
        this.value = value;
        propagate();
    }

    public synchronized double nextValue()
    {
        return this.value;
    }

}
