/* 
 * $Header: /home/projects/mule/scm/mule/mule/src/java/org/mule/util/queue/QueueConfiguration.java,v 1.2 2005/06/03 01:20:30 gnt Exp $
 * $Revision: 1.2 $
 * $Date: 2005/06/03 01:20:30 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.util.queue;

/**
 * @author <a href="mailto:gnt@codehaus.org">Guillaume Nodet</a>
 * @version $Revision: 1.2 $
 */
public class QueueConfiguration
{

    protected int capacity;
    protected boolean persistent;

    public QueueConfiguration(int capacity, boolean persistent)
    {
        this.capacity = capacity;
        this.persistent = persistent;
    }

    public QueueConfiguration(int capacity)
    {
        this(capacity, false);
    }

    public QueueConfiguration(boolean persistent)
    {
        this(0, persistent);
    }

    public QueueConfiguration()
    {
        this(0, false);
    }

    /**
     * @return Returns the capacity.
     */
    public int getCapacity()
    {
        return capacity;
    }

    /**
     * @param capacity The capacity to set.
     */
    public void setCapacity(int capacity)
    {
        this.capacity = capacity;
    }

    /**
     * @return Returns the persistent.
     */
    public boolean isPersistent()
    {
        return persistent;
    }

    /**
     * @param persistent The persistent to set.
     */
    public void setPersistent(boolean persistent)
    {
        this.persistent = persistent;
    }

}
