/*
 * $Header: /home/projects/mule/scm/mule/providers/dq/src/test/java/org/mule/providers/dq/DQEndpointTestCase.java,v 1.1 2005/06/09 10:58:42 gnt Exp $
 * $Revision: 1.1 $
 * $Date: 2005/06/09 10:58:42 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.providers.dq;

import org.mule.impl.endpoint.MuleEndpointURI;
import org.mule.tck.NamedTestCase;
import org.mule.umo.endpoint.UMOEndpointURI;

/**
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.1 $
 */
public class DQEndpointTestCase extends NamedTestCase
{
    public void testWithoutLibParam() throws Exception
    {
        UMOEndpointURI url = new MuleEndpointURI("dq://QSYS.LIB/L701QUEUE.DTAQ");
        assertEquals("dq", url.getScheme());
        assertEquals("/QSYS.LIB/L701QUEUE.DTAQ", url.getAddress());
        assertNull(url.getEndpointName());
        assertEquals(1, url.getParams().size());
        assertEquals("QSYS.LIB", url.getParams().getProperty("lib"));
    }

    public void testWithLibParam() throws Exception
    {
        UMOEndpointURI url = new MuleEndpointURI("dq://L701QUEUE.DTAQ?lib=QSYS.LIB");
        assertEquals("dq", url.getScheme());
        assertEquals("/QSYS.LIB/L701QUEUE.DTAQ", url.getAddress());
        assertNull(url.getEndpointName());
        assertEquals(1, url.getParams().size());
        assertEquals("QSYS.LIB", url.getParams().getProperty("lib"));
    }
}
