/* 
 * $Header: /home/projects/mule/scm/mule/providers/ftp/src/test/java/org/mule/providers/ftp/FtpConnectorFunctionalTestCase.java,v 1.2 2005/06/03 01:20:33 gnt Exp $
 * $Revision: 1.2 $
 * $Date: 2005/06/03 01:20:33 $
 * ------------------------------------------------------------------------------------------------------
 * 
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 * 
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file. 
 *
 */
package org.mule.providers.ftp;

import java.io.FileOutputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.mule.impl.endpoint.MuleEndpoint;
import org.mule.impl.endpoint.MuleEndpointURI;
import org.mule.providers.NullPayload;
import org.mule.tck.functional.AbstractProviderFunctionalTestCase;
import org.mule.umo.UMOEvent;
import org.mule.umo.endpoint.MalformedEndpointException;
import org.mule.umo.endpoint.UMOEndpoint;
import org.mule.umo.endpoint.UMOEndpointURI;
import org.mule.umo.provider.UMOConnector;
import org.mule.umo.provider.UMOMessageDispatcher;

/**
 * @author <a href="mailto:gnt@codehaus.org">Guillaume Nodet</a>
 * @version $Revision: 1.2 $
 */
public class FtpConnectorFunctionalTestCase extends AbstractProviderFunctionalTestCase
{

    protected static final String USERNAME = "mule";
    protected static final String PASSWORD = "mulepwd";
    protected static final String HOSTNAME = "localhost";
    protected static final String ADDRESS = "test";

    protected static transient Log logger = LogFactory.getLog(FtpConnectorFunctionalTestCase.class);

    public void testClient() throws Exception
    {
        UMOEndpointURI uri = new MuleEndpointURI(getOutDest());
        FtpConnector c = (FtpConnector) createConnector();
        c.initialise();
        UMOMessageDispatcher d = c.getDispatcher(uri.getAddress());
        UMOEvent e = getTestEvent(new NullPayload(), new MuleEndpoint("test",
                                                                      uri,
                                                                      c,
                                                                      null,
                                                                      UMOEndpoint.ENDPOINT_TYPE_SENDER,
                                                                      0,
                                                                      null));
        d.dispatch(e);
    }

    protected void sendTestData(int iterations) throws Exception
    {
        for (int i = 0; i < 100; i++) {
            FileOutputStream fos = new FileOutputStream("c:\\temp\\ftp\\test\\test" + i + ".txt");
            fos.write(("Hello" + i).getBytes());
            fos.close();
        }
    }

    protected void receiveAndTestResults() throws Exception
    {
        // TODO Auto-generated method stub
        Thread.sleep(5000);
    }

    protected UMOEndpointURI getInDest()
    {
        try {
            return new MuleEndpointURI("ftp://" + USERNAME + ":" + PASSWORD + "@" + HOSTNAME + "/" + ADDRESS);
        } catch (MalformedEndpointException e) {
            fail(e.getMessage());
            return null;
        }
    }

    protected UMOEndpointURI getOutDest()
    {
        return getInDest();
    }

    protected UMOConnector createConnector() throws Exception
    {
        FtpConnector connector = new FtpConnector();
        connector.setName("testFtp");
        connector.getDispatcherThreadingProfile().setDoThreading(false);
        return connector;
    }

}
