/*
 * $Header: /home/projects/mule/scm/mule/providers/ssl/src/test/java/org/mule/providers/ssl/SslMessageReceiverTestCase.java,v 1.5 2005/07/19 18:55:54 rossmason Exp $
 * $Revision: 1.5 $
 * $Date: 2005/07/19 18:55:54 $
 * ------------------------------------------------------------------------------------------------------
 *
 * Copyright (c) SymphonySoft Limited. All rights reserved.
 * http://www.symphonysoft.com
 *
 * The software in this package is published under the terms of the BSD
 * style license a copy of which has been included with this distribution in
 * the LICENSE.txt file.
 */
package org.mule.providers.ssl;

import com.mockobjects.dynamic.Mock;
import org.mule.impl.endpoint.MuleEndpoint;
import org.mule.providers.AbstractConnector;
import org.mule.tck.providers.AbstractMessageReceiverTestCase;
import org.mule.umo.UMOComponent;
import org.mule.umo.UMODescriptor;
import org.mule.umo.endpoint.UMOEndpoint;
import org.mule.umo.provider.UMOMessageReceiver;

/**
 * @author <a href="mailto:ross.mason@symphonysoft.com">Ross Mason</a>
 * @version $Revision: 1.5 $
 */

public class SslMessageReceiverTestCase extends AbstractMessageReceiverTestCase
{
    /**
     * Store created using
     * C:\dev\projects\mule\src\providers\ssl\src\test\conf>keytool -genkey
     * -keystore serverKeystore -keyalg rsa -alias muleserver -storepass
     * mulepassword -keypass mulepassword
     * 
     */
    public UMOMessageReceiver getMessageReceiver() throws Exception
    {
        Mock mockComponent = new Mock(UMOComponent.class);
        Mock mockDescriptor = new Mock(UMODescriptor.class);
        mockComponent.expectAndReturn("getDescriptor", mockDescriptor.proxy());
        mockDescriptor.expectAndReturn("getResponseTransformer", null);

        return new SslMessageReceiver((AbstractConnector) endpoint.getConnector(),
                                      (UMOComponent) mockComponent.proxy(),
                                      endpoint);
    }

    public UMOEndpoint getEndpoint() throws Exception
    {
        endpoint = new MuleEndpoint("ssl://localhost:12345", true);
        endpoint.setConnector(SslConnectorTestCase.createConnector(true));
        return endpoint;
    }
}
